using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Windows.Forms.Grid.Grouping;
using Syncfusion.Grouping;
using Syncfusion.Diagnostics;

namespace GGC_HideTable
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridGroupingControl1;
		private System.Windows.Forms.Button button1;
		private System.Windows.Forms.Button button2;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			
			//GridEngineFactory.Factory = new GroupingEngineFactory();
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.gridGroupingControl1 = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
			this.button1 = new System.Windows.Forms.Button();
			this.button2 = new System.Windows.Forms.Button();
			((System.ComponentModel.ISupportInitialize)(this.gridGroupingControl1)).BeginInit();
			this.SuspendLayout();
			// 
			// gridGroupingControl1
			// 
			this.gridGroupingControl1.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.gridGroupingControl1.BackColor = System.Drawing.SystemColors.Window;
			this.gridGroupingControl1.Location = new System.Drawing.Point(16, 56);
			this.gridGroupingControl1.Name = "gridGroupingControl1";
			this.gridGroupingControl1.ShowGroupDropArea = true;
			this.gridGroupingControl1.Size = new System.Drawing.Size(616, 408);
			this.gridGroupingControl1.TabIndex = 0;
			this.gridGroupingControl1.TableDescriptor.AllowNew = false;
			this.gridGroupingControl1.TableOptions.ListBoxSelectionCurrentCellOptions = Syncfusion.Windows.Forms.Grid.Grouping.GridListBoxSelectionCurrentCellOptions.None;
			this.gridGroupingControl1.Text = "gridGroupingControl1";
			this.gridGroupingControl1.VersionInfo = "4.101.0.22";
			// 
			// button1
			// 
			this.button1.Location = new System.Drawing.Point(16, 16);
			this.button1.Name = "button1";
			this.button1.Size = new System.Drawing.Size(288, 24);
			this.button1.TabIndex = 1;
			this.button1.Text = "Record Selection";
			this.button1.Click += new System.EventHandler(this.button1_Click);
			// 
			// button2
			// 
			this.button2.Location = new System.Drawing.Point(304, 16);
			this.button2.Name = "button2";
			this.button2.Size = new System.Drawing.Size(312, 24);
			this.button2.TabIndex = 2;
			this.button2.Text = "Cell Selection";
			this.button2.Click += new System.EventHandler(this.button2_Click);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(648, 478);
			this.Controls.Add(this.button2);
			this.Controls.Add(this.button1);
			this.Controls.Add(this.gridGroupingControl1);
			this.Name = "Form1";
			this.Text = "Form1";
			this.Load += new System.EventHandler(this.Form1_Load);
			((System.ComponentModel.ISupportInitialize)(this.gridGroupingControl1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}
		private int numberParentRows = 20;
		

		private DataTable GetParentTable()
		{
			DataTable dt = new DataTable("ParentTable");

			
			dt.Columns.Add(new DataColumn("Department",typeof(string))); //lower case p
			dt.Columns.Add(new DataColumn("SubDepartment",typeof(string)));
			dt.Columns.Add(new DataColumn("Value1",typeof(int)));
			dt.Columns.Add(new DataColumn("Value2", typeof(int)));

			
			for(int i = 0; i < numberParentRows; ++i)
			{
				DataRow dr = dt.NewRow();
				dr[0] = string.Format("Dept{0}",i % 2);
				dr[1] = string.Format("SubDept{0}",i % 7);
				dr[2] = (i+ 1) *3;
				dr[3] = (i+ 3) *5;
				dt.Rows.Add(dr);
			}
			return dt;
		}
		private void Form1_Load(object sender, System.EventArgs e)
		{
			DataTable parentTable = GetParentTable();
			this.gridGroupingControl1.DataSource = parentTable;
		}

		private void button1_Click(object sender, System.EventArgs e)
		{
			this.gridGroupingControl1.TableOptions.AllowSelection = GridSelectionFlags.None;  
			this.gridGroupingControl1.TableOptions.ListBoxSelectionMode = SelectionMode.One;   
			this.gridGroupingControl1.SelectedRecordsChanging +=new SelectedRecordsChangedEventHandler(gridGroupingControl1_SelectedRecordsChanging); 
			this.gridGroupingControl1.TableControlMouseDown +=new GridTableControlMouseEventHandler(gridGroupingControl1_TableControlMouseDown);
			
		}

		private void button2_Click(object sender, System.EventArgs e)
		{
			this.gridGroupingControl1.TableOptions.ListBoxSelectionMode = SelectionMode.None; 
			this.gridGroupingControl1.TableOptions.AllowSelection = GridSelectionFlags.Any ^ GridSelectionFlags.Row ; 
		}

		private void gridGroupingControl1_SelectedRecordsChanging(object sender, SelectedRecordsChangedEventArgs e)
		{
			if( e.Action == SelectedRecordsChangedType.Added )
				e.Cancel = IsRowHeaderCell;
		}

	
		bool IsRowHeaderCell = false;
		private void gridGroupingControl1_TableControlMouseDown(object sender, GridTableControlMouseEventArgs e)
		{
			GridTableCellStyleInfo  style = e.TableControl .PointToTableCellStyle(new Point(e.Inner.X,e.Inner.Y ));
			if( style != null 
				&& ( style.TableCellIdentity.TableCellType == GridTableCellType.RecordRowHeaderCell 
				|| style.TableCellIdentity.TableCellType == GridTableCellType.AlternateRecordRowHeaderCell ))
			{
					IsRowHeaderCell =true;		
			}
			else
				IsRowHeaderCell = false;

		}
	}
}
